// GAfgan.cpp: implementation of the GAfgan class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "GAfgan.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define DIR_UP      1.57    //  90
#define DIR_LEFT    2.81    // 150
#define DIR_RIGHT   0.32    //  30
#define DIR_DELTA   0.06    // zmena pri toceni
#define DIR_LR      2.5     // rozdil DIR_LEFT a DIR_RIGHT

#define ANIM_AFGANS   9
#define KADENCE       4 // stili kazdych X framu


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GAfgan::GAfgan()
{

}

GAfgan::~GAfgan()
{

}

void GAfgan::Init(int x, int y, int bAfgan, int bShoot, CD3DFont *font)
{
	m_bAfgan = bAfgan; 
	m_bShoot = bShoot;

	m_x = x;
	m_y = y;
	m_toshoot = 0;
	m_killed  = 0;

	m_font = font;

	m_angle = DIR_UP;

	for (int i = 0; i < MAX_SHOOTS; i++)
		m_gshoot[i].m_valid = false;
}

void GAfgan::Draw()
{
	d3dx.Draw(m_bAfgan, m_x, m_y, 0, 1, 1, 255, ((m_angle - DIR_RIGHT)*ANIM_AFGANS)/DIR_LR);
	for (int i = 0; i < MAX_SHOOTS; i++)
		m_gshoot[i].Draw();

	char s[50];
	sprintf(s, "%d", m_killed);
	m_font->DrawText(m_x, m_y + 50, D3DCOLOR_ARGB(255, 255, 0, 0), s, D3DFONT_CENTERED);
}

void GAfgan::Move(BOOL left, BOOL right, BOOL fire)
{
	int i;
	if (m_toshoot != 0) m_toshoot--;

	if (left)  if ((m_angle += DIR_DELTA) > DIR_LEFT)  m_angle = DIR_LEFT;
	if (right) if ((m_angle -= DIR_DELTA) < DIR_RIGHT) m_angle = DIR_RIGHT;

	for (i = 0; i < MAX_SHOOTS; i++)
		m_gshoot[i].Move();

	if (fire && m_toshoot == 0) {
		for (i = 0; i < MAX_SHOOTS; i++)
			if (m_gshoot[i].m_valid == false) break;
		if (i == MAX_SHOOTS) return;
		m_gshoot[i].Init(m_x, m_y-15, m_angle + (rand()%(int)(DIR_DELTA*200))/100.0-DIR_DELTA,m_bShoot);
		 // posunuti strely, aby letela az z hlavne
		m_gshoot[i].Move();m_gshoot[i].Move();m_gshoot[i].Move(); m_gshoot[i].Move(); m_gshoot[i].Move(); m_gshoot[i].Move();
		m_toshoot = KADENCE;
	}

}


bool GAfgan::KilledNew()
{
	if ((++m_killed % 100) == 0) return true;
	return false;
}
