// GGame.h: interface for the GGame class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GGAME_H__CFA8C460_1E15_491D_BD5F_41BEE987E784__INCLUDED_)
#define AFX_GGAME_H__CFA8C460_1E15_491D_BD5F_41BEE987E784__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GBase.h"
#include "d3dfont.h"	// Added by ClassView
#include "GAfgan.h"	    // Added by ClassView
#include "GUSA.h"	    // Added by ClassView
#include "GPlane.h"	    // Added by ClassView

#define MAX_PLAYERS      4
#define MAX_PLANES      16
#define MAX_COMPUTERS 1000

class GGame : public GBase  
{
public:
	void DestroyGFX();
	void InitGFX();
	void AddUSA(double x, double y);
	void StartGame(int players, int ground);
	virtual int  OnKey(int nChar);
	virtual void Draw();
	virtual void Move();
	virtual void Init(CMainFrame *parent);
	GGame();
	virtual ~GGame();

private:
	GAfgan m_afgan[MAX_PLAYERS];
	GUSA   m_usa[MAX_COMPUTERS];
	GPlane m_plane[MAX_PLANES];

	int    m_players; // pocvet hracu
	int    m_ground;  // id podlahy
	int    m_planes;
	int    m_lives;

	bool   m_autofire;
	bool   m_houpani;
	bool   m_pause;
	bool   m_smrti;

	// bitmapy
	int  m_bGround;
	int  m_bGameUSA;
	int  m_bGameAfgan;
	int  m_bAfgan;
	int  m_bPlaneL;
	int  m_bPlaneR;
	int  m_bUsa;
	int  m_bUsaDead[4];
	int  m_bShoot;

	CD3DFont *m_font;

};

#endif // !defined(AFX_GGAME_H__CFA8C460_1E15_491D_BD5F_41BEE987E784__INCLUDED_)
