// GMenu.cpp: implementation of the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "GMenu.h"
#include "MainFrm.h"
#include "GToplist.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GMenu::GMenu()
{
	m_font = new CD3DFont("Rubber Stamp LET", 30, D3DFONT_BOLD);
	m_fontS = new CD3DFont("VERDANA", 8, 0);
}

GMenu::~GMenu()
{
}

void GMenu::Draw()
{
	m_font->RestoreDeviceObjects();
	m_fontS->RestoreDeviceObjects();
	d3dx.BeginScene();

	d3dx.Draw(m_bGround, 400, 300, 0, 1.5625, 1.25, 255);
	m_fontS->DrawText(750, 590, D3DCOLOR_ARGB(255, 255, 255, 255), "verze 1.0", D3DFONT_CENTERED);
	m_fontS->DrawText(70,  590, D3DCOLOR_ARGB(255, 255, 255, 255), "HIPPO GAMES - 2002", D3DFONT_CENTERED);

//	d3dx.Draw(m_bPismo, 400, 300, 0, 1.5625, 1.25, 255);


	m_actual->Draw();


	d3dx.EndScene();
	m_font->InvalidateDeviceObjects();
	m_fontS->InvalidateDeviceObjects();

}

void GMenu::Init(CMainFrame *parent)
{
	GBase::Init(parent);

	m_bGround = d3dx.CreateTextureFromRes(AfxGetApp()->m_hInstance, "MENU");
	m_bPismo = d3dx.CreateTextureFromRes(AfxGetApp()->m_hInstance, "PISMO");

	m_font->InitDeviceObjects(d3dx.m_dev);
	m_fontS->InitDeviceObjects(d3dx.m_dev);

	m_Mmain.Init(m_bPismo);
	m_Mcredits.Init();
	m_Msetting.Init(m_font);
	m_Mgame.Init(m_bPismo, parent);
	m_Mtoplist.Init(m_bPismo, m_font);
	m_Mtopname.Init(m_bPismo, m_font);

	m_actual = &m_Mmain;

	toplist.LoadList();
}

int GMenu::OnKey(int nChar)
{
	switch(m_actual->OnKey(nChar)){
	case MENU_MAIN    : m_actual = &m_Mmain; break;
	case MENU_GAME    : m_actual = &m_Mgame; break;
	case MENU_CREDITS : m_actual = &m_Mcredits; break;
	case MENU_SETTING : m_actual = &m_Msetting; break;
	case MENU_TOPLIST : m_actual = &m_Mtoplist; break;
	case MENU_END     : m_pParent->PostMessage(WM_CLOSE); break;
	case MENU_TOPNAME :
		toplist.AddToList(m_killed, m_Mtopname.m_name);
		m_actual = &m_Mtoplist;
		break;
	}

	return MENU_DEFAULT;
}

void GMenu::Killed(int killed)
{
	m_killed = killed;
	m_Mtopname.Reset();
	m_actual = &m_Mtopname;
}
