// GShoot.cpp: implementation of the GShoot class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "GShoot.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define SHOOT_SPEED 5


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GShoot::GShoot()
{
	m_valid  = false;
	m_x      = 0;
	m_y      = 0;
	m_angle  = 0;
	m_bShoot = 0;
}

GShoot::~GShoot()
{

}

void GShoot::Move()
{
	if (m_valid == false) return;

	m_x += cos(m_angle) * SHOOT_SPEED;
	m_y -= sin(m_angle) * SHOOT_SPEED;

	if (m_y < 0) m_valid = false;
}

void GShoot::Init(double x, double y, double angle, int bShoot)
{
	m_x = x;
	m_y = y;
	m_angle = angle;
	m_valid = true;
	m_bShoot = bShoot;
}

void GShoot::Draw()
{
	if (m_valid == false) return;

	d3dx.Draw(m_bShoot, m_x, m_y, m_angle);
}

void GShoot::HitUSA()
{
	if (rand()%3) m_valid = false;
}

void GShoot::HitPlane()
{
	m_valid = false;
}
